#pragma once

#include "File.h"

#include <string>
#include <optional>
#include <unordered_map>

class MarkdownContentParser
{
public:
    using FileMetadataItem = std::pair<std::string, std::string>;
    using FileMetadata = std::unordered_map<std::string, std::string>;
    using FileContentBody = std::vector<std::string>;

    void run(const Path& path);

    FileContentBody getContentBody() const;

    FileMetadata getFileMetadata() const;

private:
    std::optional<FileMetadataItem> checkForMetadataItem(const std::string& line) const;

    FileMetadata mMetadata;
    FileContentBody mContentBody;
};
